Package com.mouseviator.fsuipc.helpers.avionics

# Class GPSHelper

java.lang.Object
com.mouseviator.fsuipc.helpers.avionics.GPSHelper

    public class GPSHelper
    extends java.lang.Object

This class provides methods that return data requests to gather various data from flight simulator GPS. The returned requests are usually modified to return user-friendly data type, even thought the underlying data type may be different.

Author:
  Mouseviator

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `GPSHelper()` |

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `IDataRequest<java.lang.Double>` | `getAltitude​(boolean bFeet)` | Returns request to get GPS altitude in meters of feet.
  `IDataRequest<java.lang.Double>` | `getCourseToSet​(boolean bDegrees)` | Returns request to get GPS course to set in radians or degrees.
  `IDataRequest<java.lang.Double>` | `getCrossTrackError​(boolean bNauticalMiles)` | Returns request to get GPS cross track error in meters or nautical miles.
  `IDataRequest<java.lang.String>` | `getDestinationAirportID()` | Returns request to get GPS previous waypoint string ID.
  `IDataRequest<java.lang.Integer>` | `getDestinationETA()` | Returns request to get GPS destination ETA (estimated time arrival) in seconds local time.
  `IDataRequest<java.lang.Integer>` | `getDestinationETE()` | Returns request to get GPS destination ETE (estimated time en-route) in seconds.
  `IDataRequest<java.lang.Double>` | `getDistanceToNextWaypoint​(boolean bNauticalMiles)` | Returns request to get GPS distance to next waypoint in meters or nautical miles.
  `IDataRequest<java.lang.Double>` | `getEstimatedFuelBurn​(boolean bLitres)` | Returns request to get GPS estimated fuel burn in gallons or litres.
  `IDataRequest<java.lang.Double>` | `getGroundSpeed​(boolean bKnots)` | Returns request to get GPS ground speed in m/s or knots.
  `IDataRequest<java.lang.Double>` | `getHeading​(boolean bDegrees)` | Returns request to get GPS aircraft TRUE heading in radians or degrees.
  `IDataRequest<java.lang.Double>` | `getLatitude()` | Returns request to get GPS latitude in degrees.
  `IDataRequest<java.lang.Double>` | `getLongitude()` | Returns request to get GPS longitude in degrees.
  `IDataRequest<java.lang.Double>` | `getMagBearingToNextWaypoint​(boolean bDegrees)` | Returns request to get GPS magnetic bearing to next waypoint in radians or degrees.
  `IDataRequest<java.lang.Double>` | `getMagneticTrack​(boolean bDegrees)` | Returns request to get GPS aircraft magnetic track in radians or degrees.
  `IDataRequest<java.lang.Double>` | `getMagneticVariation​(boolean bDegrees)` | Returns request to get GPS magnetic variation in radians or degrees.
  `IDataRequest<java.lang.Double>` | `getNextWaypointAircraftAltitude​(boolean bFeet)` | Returns request to get GPS next waypoint aircraft altitude in meters of feet.
  `IDataRequest<java.lang.Integer>` | `getNextWaypointETA()` | Returns request to get GPS next waypoint ETA (estimated time arrival) in seconds local time.
  `IDataRequest<java.lang.Integer>` | `getNextWaypointETE()` | Returns request to get GPS next waypoint ETE (estimated time en-route) in seconds.
  `IDataRequest<java.lang.String>` | `getNextWaypointID()` | Returns request to get GPS next waypoint string ID.
  `IDataRequest<java.lang.Double>` | `getNextWaypointLatitude()` | Returns request to get GPS next waypoint latitude in degrees.
  `IDataRequest<java.lang.Double>` | `getNextWaypointLongitude()` | Returns request to get GPS next waypoint longitude in degrees.
  `IDataRequest<java.lang.Double>` | `getPreviousWaypointAircraftAltitude​(boolean bFeet)` | Returns request to get GPS previous waypoint aircraft altitude in meters of feet.
  `IDataRequest<java.lang.String>` | `getPreviousWaypointID()` | Returns request to get GPS previous waypoint string ID.
  `IDataRequest<java.lang.Double>` | `getPreviousWaypointLatitude()` | Returns request to get GPS previous waypoint latitude in degrees.
  `IDataRequest<java.lang.Double>` | `getPreviousWaypointLongitude()` | Returns request to get GPS previous waypoint longitude in degrees.
  `IDataRequest<java.lang.Byte>` | `getPreviousWaypointValidFlag()` | Returns request to get GPS previous waypoint valid flag.
  `IDataRequest<java.lang.Double>` | `getRequiredHeading​(boolean bDegrees)` | Returns request to get GPS aircraft required TRUE heading in radians or degrees.
  `IDataRequest<java.lang.Double>` | `getRouteTotalDistance​(boolean bNauticalMiles)` | Returns request to get GPS total route distance in meters or nautical miles.
  `IDataRequest<java.lang.Double>` | `getTrackError​(boolean bDegrees)` | Returns request to get GPS track error in radians or degrees.
  `IDataRequest<java.lang.Double>` | `getVerticalSpeed()` | Returns request to get GPS vertical speed.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### GPSHelper

    public GPSHelper()

- ## Method Details

  - ### getAltitude

    public IDataRequest<java.lang.Double> getAltitude​(boolean bFeet)
    Returns request to get GPS altitude in meters of feet. READ ONLY!
    Parameters:
      `bFeet` - True to get result in feet, False for meters.
    Returns:
      Data request to get GPS altitude in meters or feet.

  - ### getLongitude

    public IDataRequest<java.lang.Double> getLongitude()
    Returns request to get GPS longitude in degrees. Positive values = E, negative values = W. READ ONLY!
    Returns:
      Data request to get GPS longitude in degrees.

  - ### getLatitude

    public IDataRequest<java.lang.Double> getLatitude()
    Returns request to get GPS latitude in degrees. Positive values = N, negative values = S. READ ONLY!
    Returns:
      Data request to get GPS latitude in degrees.

  - ### getMagneticVariation

    public IDataRequest<java.lang.Double> getMagneticVariation​(boolean bDegrees)
    Returns request to get GPS magnetic variation in radians or degrees. READ ONLY!
    Parameters:
      `bDegrees` - True to get result in degrees, False for radians.
    Returns:
      Data request to get GPS Magnetic variation in radians or degrees.

  - ### getVerticalSpeed

    public IDataRequest<java.lang.Double> getVerticalSpeed()
    Returns request to get GPS vertical speed. READ ONLY!
    Returns:
      Data request to get GPS vertical speed.

  - ### getGroundSpeed

    public IDataRequest<java.lang.Double> getGroundSpeed​(boolean bKnots)
    Returns request to get GPS ground speed in m/s or knots. READ ONLY!
    Parameters:
      `bKnots` - True to get result in knots, False for m/s.
    Returns:
      Data request to get GPS Ground speed in m/s or knots.

  - ### getHeading

    public IDataRequest<java.lang.Double> getHeading​(boolean bDegrees)
    Returns request to get GPS aircraft TRUE heading in radians or degrees. READ ONLY!
    Parameters:
      `bDegrees` - True to get result as degrees, False for radians.
    Returns:
      Data request to get GPS TRUE heading in radians or degrees.

  - ### getRequiredHeading

    public IDataRequest<java.lang.Double> getRequiredHeading​(boolean bDegrees)
    Returns request to get GPS aircraft required TRUE heading in radians or degrees. READ ONLY!
    Parameters:
      `bDegrees` - True to get result as degrees, False for radians.
    Returns:
      Data request to get GPS required TRUE heading in radians or degrees.

  - ### getMagneticTrack

    public IDataRequest<java.lang.Double> getMagneticTrack​(boolean bDegrees)
    Returns request to get GPS aircraft magnetic track in radians or degrees. READ ONLY!
    Parameters:
      `bDegrees` - True to get result as degrees, False for radians.
    Returns:
      Data request to get GPS Aircraft magnetic track in radians or degrees.

  - ### getDistanceToNextWaypoint

    public IDataRequest<java.lang.Double> getDistanceToNextWaypoint​(boolean bNauticalMiles)
    Returns request to get GPS distance to next waypoint in meters or nautical miles. READ ONLY!
    Parameters:
      `bNauticalMiles` - True to get result as nautical miles, False for meters.
    Returns:
      Data request to get GPS distance to next waypoint.

  - ### getMagBearingToNextWaypoint

    public IDataRequest<java.lang.Double> getMagBearingToNextWaypoint​(boolean bDegrees)
    Returns request to get GPS magnetic bearing to next waypoint in radians or degrees. degrees. READ ONLY!
    Parameters:
      `bDegrees` - True to get result in degrees, False for radians.
    Returns:
      Data request to get GPS magnetic bearing to next waypoint.

  - ### getCrossTrackError

    public IDataRequest<java.lang.Double> getCrossTrackError​(boolean bNauticalMiles)
    Returns request to get GPS cross track error in meters or nautical miles. READ ONLY!
    Parameters:
      `bNauticalMiles` - True to get result as nautical miles, False for meters.
    Returns:
      Data request to get GPS cross track error.

  - ### getTrackError

    public IDataRequest<java.lang.Double> getTrackError​(boolean bDegrees)
    Returns request to get GPS track error in radians or degrees. degrees. READ ONLY!
    Parameters:
      `bDegrees` - True to get result in degrees, False for radians.
    Returns:
      Data request to get GPS track error.

  - ### getPreviousWaypointValidFlag

    public IDataRequest<java.lang.Byte> getPreviousWaypointValidFlag()
    Returns request to get GPS previous waypoint valid flag. READ ONLY!
    Returns:
      Data request to get GPS previous waypoint valid flag. Request value will be 0 if not valid.

  - ### getPreviousWaypointID

    public IDataRequest<java.lang.String> getPreviousWaypointID()
    Returns request to get GPS previous waypoint string ID. READ ONLY!
    Returns:
      Data request to get GPS previous waypoint string ID.

  - ### getPreviousWaypointLongitude

    public IDataRequest<java.lang.Double> getPreviousWaypointLongitude()
    Returns request to get GPS previous waypoint longitude in degrees. Positive values = E, negative values = W. READ ONLY!
    Returns:
      Data request to get GPS previous waypoint longitude in degrees.

  - ### getPreviousWaypointLatitude

    public IDataRequest<java.lang.Double> getPreviousWaypointLatitude()
    Returns request to get GPS previous waypoint latitude in degrees. Positive values = N, negative values = S. READ ONLY!
    Returns:
      Data request to get GPS previous waypoint latitude in degrees.

  - ### getPreviousWaypointAircraftAltitude

    public IDataRequest<java.lang.Double> getPreviousWaypointAircraftAltitude​(boolean bFeet)
    Returns request to get GPS previous waypoint aircraft altitude in meters of feet. READ ONLY!
    Parameters:
      `bFeet` - True to get result in feet, False for meters.
    Returns:
      Data request to get GPS previous waypoint aircraft altitude in meters or feet.

  - ### getNextWaypointID

    public IDataRequest<java.lang.String> getNextWaypointID()
    Returns request to get GPS next waypoint string ID. READ ONLY!
    Returns:
      Data request to get GPS next waypoint string ID.

  - ### getNextWaypointLongitude

    public IDataRequest<java.lang.Double> getNextWaypointLongitude()
    Returns request to get GPS next waypoint longitude in degrees. Positive values = E, negative values = W. READ ONLY!
    Returns:
      Data request to get GPS next waypoint longitude in degrees.

  - ### getNextWaypointLatitude

    public IDataRequest<java.lang.Double> getNextWaypointLatitude()
    Returns request to get GPS next waypoint latitude in degrees. Positive values = N, negative values = S. READ ONLY!
    Returns:
      Data request to get GPS next waypoint latitude in degrees.

  - ### getNextWaypointAircraftAltitude

    public IDataRequest<java.lang.Double> getNextWaypointAircraftAltitude​(boolean bFeet)
    Returns request to get GPS next waypoint aircraft altitude in meters of feet. READ ONLY!
    Parameters:
      `bFeet` - True to get result in feet, False for meters.
    Returns:
      Data request to get GPS next waypoint aircraft altitude in meters or feet.

  - ### getNextWaypointETE

    public IDataRequest<java.lang.Integer> getNextWaypointETE()
    Returns request to get GPS next waypoint ETE (estimated time en-route) in seconds. READ ONLY!
    Returns:
      Data request to get GPS next waypoint ETE in seconds.

  - ### getNextWaypointETA

    public IDataRequest<java.lang.Integer> getNextWaypointETA()
    Returns request to get GPS next waypoint ETA (estimated time arrival) in seconds local time. READ ONLY!
    Returns:
      Data request to get GPS next waypoint ETA in seconds.

  - ### getCourseToSet

    public IDataRequest<java.lang.Double> getCourseToSet​(boolean bDegrees)
    Returns request to get GPS course to set in radians or degrees. READ ONLY!
    Parameters:
      `bDegrees` - True to get result as degrees, False for radians.
    Returns:
      Data request to get GPS course to set.

  - ### getDestinationAirportID

    public IDataRequest<java.lang.String> getDestinationAirportID()
    Returns request to get GPS previous waypoint string ID. READ ONLY!
    Returns:
      Data request to get GPS previous waypoint string ID.

  - ### getDestinationETE

    public IDataRequest<java.lang.Integer> getDestinationETE()
    Returns request to get GPS destination ETE (estimated time en-route) in seconds. READ ONLY! NOTE THAT the FSUIPC offset status document states this AS NOT WORKING, HOPING FOR ADDITIONS TO SimConnect.
    Returns:
      Data request to get GPS destination ETE in seconds.

  - ### getDestinationETA

    public IDataRequest<java.lang.Integer> getDestinationETA()
    Returns request to get GPS destination ETA (estimated time arrival) in seconds local time. READ ONLY! NOTE THAT the FSUIPC offset status document states this AS NOT WORKING, HOPING FOR ADDITIONS TO SimConnect.
    Returns:
      Data request to get GPS destination ETA in seconds.

  - ### getRouteTotalDistance

    public IDataRequest<java.lang.Double> getRouteTotalDistance​(boolean bNauticalMiles)
    Returns request to get GPS total route distance in meters or nautical miles. READ ONLY! NOTE THAT the FSUIPC offset status document states this AS NOT WORKING, HOPING FOR ADDITIONS TO SimConnect.
    Parameters:
      `bNauticalMiles` - True to get result as nautical miles, False for meters.
    Returns:
      Data request to get GPS total route distance.

  - ### getEstimatedFuelBurn

    public IDataRequest<java.lang.Double> getEstimatedFuelBurn​(boolean bLitres)
    Returns request to get GPS estimated fuel burn in gallons or litres. READ ONLY! NOTE THAT the FSUIPC offset status document states this AS NOT WORKING, HOPING FOR ADDITIONS TO SimConnect.
    Parameters:
      `bLitres` - True to get result as litres, False for gallons.
    Returns:
      Data request to get GPS estimated fuel burn in gallons or litres.